



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL 调优基础(二) Linux内存管理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL 调优基础(二) Linux内存管理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 17:41:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>进程的运行，必须使用内存。下图是Linux中进程中的内存的分布图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/699877/201509/699877-20150930215741465-68322585.png" /></p>
<p>其中最重要的 heap segment 和 stack segment。其它内存段基本是大小固定的。注意stack是向低地址增长的，和heap相反。另外进程的内存地址从0开始，是因为使用的是虚拟内存。所以存在虚拟内存到物理内存的映射。目前服务器一般都是64位的，32位的已经极少了，32为对内存有极大限制。</p>
<p><strong>1. Linux 虚拟内存</strong></p>
<p>Linux是通过虚拟内存的方式来管理内存的。虚拟内存和物理内存之间存在映射关系。当进程在CPU上运行时，虚拟内存就会映射到物理内存，供CPU来访问。</p>
<p>applications do not allocate physical memory, but request a memory map of a certain size at the Linux kernel and in exchange receive a map in virtual memory. As you can see, virtual memory does not necessarily have to be mapped into physical memory. If your application allocates a large amount of memory, some of it might be mapped to the swap file on the disk subsystem.</p>
<p>图示 进程虚拟内存 = 进程物理内存 + 进程swap(page out):</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/699877/201510/699877-20151001110516121-576501230.png" /></p>
<p>上图是top命令的截图，可以看到：mysqld 使用的虚拟内存为 735M，而常驻物理内存为 430M，所以其余的305M被swap out了(实际上是延迟分配)。</p>
<p><strong>VIRT</strong>：The total amount of virtual memory used by the task. It includes all code, data and shared libraries plus pages that have been swapped out.</p>
<p><strong>RES</strong>: Resident size (kb)。The <strong>non-swapped physical memory</strong> a task is using(常驻内存).</p>
<p>Linux handles the memory resource far more efficiently. The default configuration of the virtual memory manager allocates all available free <br />memory space as <strong>disk cache</strong>. Hence it is not unusual to see productive Linux systems that boast gigabytes of memory but only have 20 MB of that memory free. In the same context, Linux also handles swap space very efficiently. Swap space being used does not indicate a memory bottleneck but proves how efficiently Linux handles system resources.</p>
<p>There is no need to be alarmed if you find the swap partition filled to 50%. The fact that swap space is being used does not indicate a memory bottleneck; instead it proves how efficiently Linux handles system resources.</p>
<p>可见，系统显示空闲的内存很少，并不表示真的存在内存瓶颈；swap分区被使用了，也不代表存在内存瓶颈。</p>
<p><strong>内存的分配</strong>：</p>
<p>Linux 管理内存是通过内存page为单位的，一般一个page为4K。Linux通过一个维持一个free内存的列表来管理和分配内存，并且维持内存的连续，防止内存碎片的产生。该系统被称为buddy system。内存的分配和管理全依靠buddy system.</p>
<p><strong>内存的回收(page frame reclaiming)</strong>：</p>
<p>当空闲内存不足时，就涉及到内存的回收。内存的回收有两种方式：回收用于缓存磁盘文件的 page cache(disk cache)；swap out/page out 其它非活跃进程的内存；而且优先回收用于文件缓存的内存(disk cache)：</p>
<p>When <strong>kswapd </strong>reclaims pages, it would rather shrink the page cache than page out (or swap out) the pages owned by processes.</p>
<p>然后会扫描内存的 active list 和 inactive list，根据LRU原则将active的page移到inactive，然后将inactive list中的page swap out.</p>
<p>active list 和 inactive list，可以用vmstat -a 查看到：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# vmstat -a<br />
procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu-----<br />
 r  b   swpd   free  inact active   si   so    bi    bo   in   cs us sy id wa st
                                          </pre>
</div>
<p>kswapd: kernel swap daemon</p>
<p><strong>内存的两大主要用处</strong>：</p>
<p>The pages are used mainly for two purposes: page and process address space. The page cache is pages mapped to a file on disk. The <br />cache pages that belong to a process address space (called anonymous memory because it is not mapped to any files, and it has no name) are used for heap and stack.</p>
<p>一、disk cache(page cache, file cache)；</p>
<p>二、进程使用(anonymous memory、heap 和 stack)</p>
<p>kswapd 处理swap in 和swap out; 而 pdflush 处理disk cache到磁盘的刷新。</p>
<p><strong>2. 如何尽量避免swap对mysql的影响</strong></p>
<p>控制系统kswapd在内核中有一个专门的参数：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# cat /proc/sys/vm/swappiness
</pre>
</div>
<p>我们把 <strong>vm.swappiness = 0</strong> 设置好，就可以在内存不足时，<strong>尽量避免系统发生swap，而尽量去 flush disk cache</strong>. 但是最新的Linux内核修改了对vm.swappingness=0 的解释，如果设置成0，可能会发生00M，而将mysqld给kill掉。新内核(2.6.32-303.el6及以后)推荐的做法是：</p>
<p>1）尽量保证Linux操作系统还有足够的内存；</p>
<p>2）最新的内核，建议把<strong>vm.swappiness设置1</strong>；</p>
<p>3）考虑设置 /proc/$(pidof -s mysqld)/oom_adj为较小的值来尽量避免MySQL由于内存不足而被关闭;</p>
<p>4）还可以在 mysqld 的配置文件 my.cnf 中[mysqld]段中加入 <strong>memlock=1</strong> ，然后重启，避免mysqld发生swap，但是可能会被Linux oom kill掉.</p>
<p>具体参见：http://www.woqutech.com/?p=1397</p>
<p><strong>3. 如何修改 oom_adj 值</strong></p>
<p>查看mysqld的oom_ajd值：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# cat /proc/`pidof -s mysqld`/oom_adj

[root@localhost ~]# cat /proc/$(pidof -s mysqld)/oom_adj
</pre>
</div>
<p>默认值为0. 当我们设置为-17时，对于该进程来说，就不会触发OOM机制，被杀掉。修改：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# echo -17 &gt; /proc/$(pidof mysqld)/oom_adj<br />
[root@localhost ~]# cat /proc/$(pidof mysqld)/oom_adj<br />
-</pre>
</div>
<p>这里为什么是-17呢？这和Linux的实现有关系。在Linux内核中的oom.h文件中，可以看到下面的定义：</p>
<div>
<pre class="prettyprint linenums"> /* /proc//oom_adj set to -17 protects from the oom-killer */

#define OOM_DISABLE (-17)

/* inclusive */

#define OOM_ADJUST_MIN (-16)

#define OOM_ADJUST_MAX 15 </pre>
</div>
<p>这个oom_adj中的变量的范围为15到-16之间。越大越容易被kill。oom_score就是它计算出来的一个值，就是根据这个值来选择哪些进程被kill掉的。</p>
<p>总之，通过上面的分析可知，满足下面的条件后，就是启动OOM机制。</p>
<p>1) VM里面分配不出更多的page（注意linux kernel是延迟分配page策略，及用到的时候才alloc；所以malloc + memset才有效）。</p>
<p>2) 用户地址空间不足，这种情况在32bit机器上及user space超过了3GB，在64bit机器上不太可能发生。</p>
<p>具体参见：http://blog.chinaunix.net/uid-20788636-id-4308527.html</p>
<p>其实设置mysqld的oom_adj不是最好的选择，mysqld不会被kill，必然就会导致其它进程被kill掉；最好还是保障内存充足或者设置vm.swappiness=1比较好</p>
<p><strong>4. 内存瓶颈的检测</strong></p>
<p>Linux内存的瓶颈，主要在于查看是否有比较严重的 swap 的发生(swap out/page out)。其它空虚内存的大小，swap分区被使用都不能说明说明问题。</p>
<p><strong>区分 swap out 和 page out</strong>:</p>
<p>Page out moves individual pages to swap space on the disk; swapping is a bigger operation that moves the entire address space of a process to swap space in one operation.(page out 是指将单独的page交换到磁盘，而swap out是指将整个进程的内存交换到磁盘)</p>
<p><strong>使用 vmstat 从整个系统层面查看swap out</strong>：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# vmstat 2<br />
procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu-----<br />
 r  b   swpd   free   buff  cache   si   so    bi    bo   in   cs us sy id wa st
</pre>
</div>
<p>其中的 swap si: 表示每秒 swap in; so：表示每秒swap out;</p>
<div>
<pre class="prettyprint linenums">   Swap<br />
       si: Amount of memory swapped in from disk (/s).<br />
       so: Amount of memory swapped to disk (/s).</pre>
</div>
<p><strong><strong>使用 sar -B 从整个系统层面查看page out</strong>：</strong></p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# sar -B<br />
Linux 2.6.-.el6.i686 (localhost.localdomain)       //      _i686_  ( CPU)

:: AM       LINUX RESTART

:: AM  pgpgin/s pgpgout/s   fault/s  majflt/s  pgfree/s pgscank/s pgscand/s pgsteal/s    %vmeff<br />
:: AM     39.84      4.85    340.32      0.21     39.40      0.00      0.00      0.00      0.00<br />
:: AM      0.06      2.76     10.69      0.00      3.21      0.00      0.00      0.00      0.00<br />
:: AM      0.14      2.68     10.16      0.00      3.08      0.00      0.00      0.00      0.00<br />
:: AM     69.58     13.07    154.16      0.01     47.29      0.00      0.00      0.00      0.00<br />
:: AM      1.84      3.93     28.39      0.02      9.17      0.00      0.00      0.00      0.00<br />
:: PM      0.00      3.20     19.70      0.00     10.87      0.00      0.00      0.00      0.00<br />
:: PM      0.01      2.90     31.96      0.00      8.77      0.00      0.00      0.00      0.00<br />
:: PM      0.06      3.06     40.04      0.00     10.98      0.00      0.00      0.00      0.00<br />
:: PM      2.17      3.81     81.19      0.02     21.63      0.00      0.00      0.00      0.00<br />
Average:        12.62      4.47     79.63      0.03     17.15      0.00      0.00      0.00      0.00

:: PM       LINUX RESTART

:: PM  pgpgin/s pgpgout/s   fault/s  majflt/s  pgfree/s pgscank/s pgscand/s pgsteal/s    %vmeff<br />
:: PM      6.22      3.99     93.05      0.04     22.89      0.00      0.00      0.00      0.00<br />
Average:         6.22      3.99     93.05      0.04     22.89      0.00      0.00      0.00      0.00<br />
[root@localhost ~]# sar -B 2 3<br />
Linux 2.6.-.el6.i686 (localhost.localdomain)       //      _i686_  ( CPU)

:: PM  pgpgin/s pgpgout/s   fault/s  majflt/s  pgfree/s pgscank/s pgscand/s pgsteal/s    %vmeff<br />
:: PM      0.00      0.00     26.63      0.00     30.15      0.00      0.00      0.00      0.00<br />
:: PM      0.00      0.00     19.70      0.00     30.30      0.00      0.00      0.00      0.00<br />
:: PM      0.00      0.00     15.00      0.00     30.00      0.00      0.00      0.00      0.00<br />
Average:         0.00      0.00     20.44      0.00     30.15      0.00      0.00      0.00      0.00</pre>
</div>
<p>sar -B 取的是从系统启动到目前的平均值；sar -B 2 3 是指每隔2秒取值，总共取值3次。输出字段的含义如下：</p>
<div>
<pre class="prettyprint linenums">       -B     Report  paging  statistics. Some of the metrics below are available only with post 2.5<br />
              kernels. The following values are displayed:

              pgpgin/s<br />
                     Total number of kilobytes the system paged in from disk per second.  Note: With<br />
                     old  kernels (2.2.x) this value is a number of blocks per second (and not kilo-<br />
                     bytes).

              pgpgout/s<br />
                     Total number of kilobytes the system paged out to disk per second.  Note:  With<br />
                     old  kernels (2.2.x) this value is a number of blocks per second (and not kilo-<br />
                     bytes).

              fault/s<br />
                     Number of page faults (major + minor) made by the system per second.   This  is<br />
                     not  a  count of page faults that generate I/O, because some page faults can be<br />
                     resolved without I/O.

              majflt/s<br />
                     Number of major faults the  system  has  made  per  second,  those  which  have<br />
                     required loading a memory page from disk.

              pgfree/s<br />
                     Number of pages placed on the free list by the system per second.

              pgscank/s<br />
                     Number of pages scanned by the kswapd daemon per second.

              pgscand/s<br />
                     Number of pages scanned directly per second.

              pgsteal/s<br />
                     Number  of  pages the system has reclaimed from cache (pagecache and swapcache)<br />
                     per second to satisfy its memory demands.

              %vmeff<br />
                     Calculated as pgsteal / pgscan, this is a metric  of  the  efficiency  of  page<br />
                     reclaim.  If  it is near % then almost every page coming off the tail of the<br />
                     inactive list is being reaped. If it gets too low (e.g. less than %) then the<br />
                     virtual  memory  is having some difficulty.  This field is displayed as zero if<br />
                     no pages have been scanned during the interval of time.</pre>
</div>
<p>pgpgout/s 表示就是每秒的page out 的KB数量。majflt/s 也是极为重要的指标，该指标涉及到虚拟内存的 page fault机制。</p>
<p><strong>虚拟内存的 page fault机制</strong>：</p>
<p>linux 使用虚拟内存层来映射物理地址空间，这种映射在某种意义上是说当一个进程开始运行，内核仅仅映射其需要的那部分，内核首先会搜索 CPU缓存和物理内存，如果没有找到内核则开始一次 MPF， 一次 MPF 即是一次对磁盘子系统的请求，它将数据页从磁盘和缓存读入 RAM。一旦内存页被映射到高速缓冲区，内核便会试图使用这些页，被称作 MnPF,MnPF 通过重复使用内存页而缩短了内核时间。</p>
<p>文件缓冲区(disk cache)可使内核减少对 MPFs 和 MnPFs 的使用， 随着系统不断地 IO 操作， 缓冲区会随之增大， 直至内存空闲空间不足并开始回收.</p>
<p><strong>使用 free 查看空闲内存</strong>：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# free<br />
             total       used       free     shared    buffers     cached<br />
Mem:<br />
-/+ buffers/cache:<br />
Swap:<br />
[root@localhost ~]# free -m<br />
             total       used       free     shared    buffers     cached<br />
Mem:<br />
-/+ buffers/cache:<br />
Swap:                          </pre>
</div>
<p>1g的内存，1g的swap分区，使用了616M，空闲390M; swap分区没有被使用，全部空闲。</p>
<p>其实free内存很小不能说明问题，但是free比较大，却能说明内存充足。</p>
<p>swap如果大部分被使用，或者全部使用也能说明 swap 严重，当然最好结合 vmstat 来综合考虑。</p>
<p><strong>使用 &nbsp;ps -mp 1959 -o THREAD,pmem,rss,vsz,tid,pid 查看mysqld的内存和CPU使用情况</strong>：</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# pidof -s mysqld

[root@localhost ~]# ps -mp 1959 -o THREAD,pmem,rss,vsz,tid,pid<br />
USER     %CPU PRI SCNT WCHAN  USER SYSTEM %MEM   RSS    VSZ   TID   PID<br />
mysql     0.6   -    - -         -      - 42.8      -<br />
mysql     0.1      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -<br />
mysql     0.0      - -         -      -    -     -      -       -</pre>
</div>
<p><strong>使用 pmap 查看进程的内存分布情况</strong>：</p>
<p>The pmap command reports the <strong>memory map</strong> of a process or processes.</p>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# pmap -x 1959<br />
:   /usr/local/mysql/bin/mysqld --basedir=/usr/local/mysql --datadir=/var/lib/mysql --plugin-dir=/usr/local/mysql/lib/plugin --user=mysql --log-error=/var/log/mysqld.log --pid-file=/var/mysql/mysqld.pid --socket=/var/lib/mysql/mysql.sock<br />
Address   Kbytes     RSS   Dirty Mode   Mapping<br />
                      r-x--    [ anon ]<br />
002e0000                    r-x--  libnss_files-2.12.so<br />
002ec000                      r----  libnss_files-2.12.so<br />
002ed000                      rw---  libnss_files-2.12.so<br />
003fb000                   r-x--  libgcc_s-4.4.-.so.<br />
                      rw---  libgcc_s-4.4.-.so.<br />
0041b000                     r-x--  libcrypt-2.12.so<br />
                      r----  libcrypt-2.12.so<br />
                      rw---  libcrypt-2.12.so<br />
                    rw---    [ anon ]<br />
0044d000                  r-x--  libfreebl3.so<br />
004a9000                      -----  libfreebl3.so<br />
004aa000                      r----  libfreebl3.so<br />
004ab000                      rw---  libfreebl3.so<br />
004ac000                   rw---    [ anon ]<br />
0053e000                  r-x--  ld-2.12.so<br />
0055c000                      r----  ld-2.12.so<br />
0055d000                      rw---  ld-2.12.so<br />
                      r-x--  libaio.so.1.0.<br />
                      rw---  libaio.so.1.0.<br />
                 r-x--  libc-2.12.so<br />
006f4000                      r----  libc-2.12.so<br />
006f6000                      rw---  libc-2.12.so<br />
006f7000                   rw---    [ anon ]<br />
006fc000                    r-x--  libpthread-2.12.so<br />
                      r----  libpthread-2.12.so<br />
                      rw---  libpthread-2.12.so<br />
                      rw---    [ anon ]<br />
                     r-x--  libdl-2.12.so<br />
0071c000                      r----  libdl-2.12.so<br />
0071d000                      rw---  libdl-2.12.so<br />
                    r-x--  librt-2.12.so<br />
                      r----  librt-2.12.so<br />
                      rw---  librt-2.12.so<br />
0072b000                   r-x--  libm-2.12.so<br />
                      r----  libm-2.12.so<br />
                      rw---  libm-2.12.so<br />
07b14000                  r-x--  libstdc++.so.6.0.<br />
07bf5000                   r----  libstdc++.so.6.0.<br />
07bf9000                      rw---  libstdc++.so.6.0.<br />
07bfb000                     rw---    [ anon ]<br />
               r-x--  mysqld<br />
08c18000               rw---  mysqld<br />
08d4a000                rw---    [ anon ]<br />
0a809000             rw---    [ anon ]<br />
8abfd000                      -----    [ anon ]<br />
8abfe000                  rw---    [ anon ]<br />
8b5fe000                      -----    [ anon ]<br />
8b5ff000                  rw---    [ anon ]<br />
8bfff000                      -----    [ anon ]<br />
8c000000                  rw---    [ anon ]<br />
8ca00000               rw---    [ anon ]<br />
8cbf7000                      -----    [ anon ]<br />
8cbf8000                rw---    [ anon ]<br />
8d5f8000                      -----    [ anon ]<br />
8d5f9000                  rw---    [ anon ]<br />
8dff9000                      -----    [ anon ]<br />
8dffa000                  rw---    [ anon ]<br />
8e9fa000                      -----    [ anon ]<br />
8e9fb000                  rw---    [ anon ]<br />
8f3fb000                      -----    [ anon ]<br />
8f3fc000                  rw---    [ anon ]<br />
8fdfc000                      -----    [ anon ]<br />
8fdfd000            rw---    [ anon ]<br />
90c00000                    rw---    [ anon ]<br />
90c21000                    -----    [ anon ]<br />
90d04000                      -----    [ anon ]<br />
90d05000                  rw---    [ anon ]<br />
90d35000                      -----    [ anon ]<br />
90d36000                  rw---    [ anon ]<br />
                      -----    [ anon ]<br />
                  rw---    [ anon ]<br />
                      -----    [ anon ]<br />
                  rw---    [ anon ]<br />
92b38000                      -----    [ anon ]<br />
92b39000                  rw---    [ anon ]<br />
                      -----    [ anon ]<br />
9353a000                  rw---    [ anon ]<br />
93f3a000                      -----    [ anon ]<br />
93f3b000                  rw---    [ anon ]<br />
9493b000                      -----    [ anon ]<br />
9493c000                  rw---    [ anon ]<br />
9533c000                      -----    [ anon ]<br />
9533d000                  rw---    [ anon ]<br />
95d3d000                      -----    [ anon ]<br />
95d3e000                  rw---    [ anon ]<br />
9673e000                      -----    [ anon ]<br />
9673f000         rw---    [ anon ]<br />
9e9ab000       rw---    [ anon ]<br />
b774b000                      rw---    [ anon ]<br />
bfc28000                   rw---    [ stack ]<br />
-------- ------- ------- ------- -------<br />
total kB         -       -       -</pre>
</div>
<p>上面字段的含义：</p>
<div>
<pre class="prettyprint linenums">EXTENDED AND DEVICE FORMAT FIELDS<br />
       Address:   start address of map<br />
       Kbytes:    size of map in kilobytes<br />
       RSS:       resident set size in kilobytes<br />
       Dirty:     dirty pages (both shared and private) in kilobytes<br />
       Mode:      permissions on map: read, write, execute, shared, private (copy on write)<br />
       Mapping:   file backing the map, or &rsquo;[ anon ]&rsquo; for allocated memory, or  &rsquo;[ stack ]&rsquo; for the program stack<br />
       Offset:    offset into the file<br />
       Device:    device name (major:minor)</pre>
</div>
<p>Mapping 字段说明是通过文件map使用的内存，还是[ anon ] 实际分配的内存，还是[ stack ] 栈使用的内存。</p>
<p>最后一行的 total KB 752740 的结果 和上面一条命令中 VSZ: 752744(虚拟内存) 是一致的。</p>
<p><strong>5. 内存的调优</strong></p>
<p>上面我们说到内存的瓶颈，主要看 swap out, page out, major page fault. 它们会极大的影响性能，特别是swap out. 所以内存调优也就是减少和防止它们的出现。</p>
<p>1）使用 hugepage 可以避免swap out; 但是 huagepage也是有代价的(导致page争用加剧)，一定要事先测试；</p>
<p>2）修改 vm.swapingness, 优先flush disk cache，尽量减少page out 和 swap out; 但是flush disk cache又可能会导致 major page fault的产生；</p>
<p>3）disk cache刷新到磁盘有两个内核参数调节：vm.dirty_background_ratio=10; 默认值为10，表示disk cache中的脏页数量达到10%时，pdflush内核</p>
<p>线程会被调用，<strong>异步</strong>刷新disk cache; vm.dirty_ratio=20; 默认值20，表示disk cache中的脏页数量达到20%时，会进行<strong>同步</strong>的disk cache刷新，从而</p>
<p>会<strong>阻塞系统中应用进程的IO操作</strong>！我们可以调低vm.dirty_background_ratio来降低disk cache对mysql使用内存的影响，但是可能会增加磁盘IO；</p>
<p>4）加内存；</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ojml1q.html">How to make your assembly more secure from referencing by unauthorized bits</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql50e08.html">【 2013 Multi-University Training Contest 6 】</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72x4j9.html">onethink和thinkphp3&period;2学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e24gx8.html">jQuery自定义插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wk559.html">Android获取屏幕宽和高</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k617rq.html">&lbrack;转&rsqb;嵌入式SQC文件编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2xw48.html">&lbrack;1015&rsqb;&lbrack;JSOI2008&rsqb;星球大战starwar（并查集）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jk3ne8.html">mvc-2事件监听</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10wr69.html">【leetcode❤python】206&period; Reverse Linked List</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xge7m8.html">&lbrack;POJ 2586&rsqb; Y2K Accounting Bug （贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e104lm9.html">C&plus;&plus;中的RAII机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2m679.html">JS复制对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5loj8.html">mac 下svn降级</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokv4xq.html">C&num;-实验3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meweypq.html">LinkCode 整数排序II</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ylrwn8.html">java实现组合问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglejd8.html">iOS平台添加Google Admob -2&sol;2（Unity3D开发之八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5oln8.html">UNIX环境高级编程&mdash;&mdash;I&sol;O多路转接（select、pselect和poll）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jr7638.html">sql server 中getdate&lpar;&rpar; 的日期时间字符串表示法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11vvlq.html">linux配置gitlab步骤</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93g1pw8.html">extern的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8erk7zq.html">Guava学习笔记：Guava新增集合类型-Bimap</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8ze77n8.html">CentOS6&period;5下安装PostgreSQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jd4x09.html">orcl的小技巧和分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy0jnx8.html">十一个行为模式之责任链模式&lpar;Responsible Chain Pattern&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlp6l09.html">基于 Node&period;js 平台的web开发框架-----express</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jd5lw9.html">js引入php 用来加载静态页面 输出到页面中</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mr1x09.html">word-wrap、white-space和word break的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv3gyz8.html">sqlite原子提交原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/49575oeq.html">System&period;currentTimeMillis&lpar;&rpar;与SystemClock&period;uptimeMillis&lpar;&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
